################################################################################
#
#       This is part of CATBox (Combinatorial Algorithm Toolbox)
#       version 1.2.7 from 1/25/2021. You can find more information at
#       http://schliep.org/CATBox/
#
#	file:   BFS-Visualization-1.pro
#	author: Alexander Schliep (alexander@schliep.org)
#
#       Copyright (C) 1998-2020, Winfried Hochstaettler and Alexander Schliep.
#	(C) 2010 Springer Verlag.
#       
#	This is part of the Springer textbook "CATBox - an interactive course in 
#       discrete optimization".
#
#       All rights reserved. Do not distribute without written permission. 
#
#
#
#
################################################################################

# Options ----------------------------------------------------------------------
breakpoints = [6]
interactive = [1]
graphDisplays = 1
self.NeededProperties({'Connected':1, 'Undirected':1})
about = """<HTML>
<HEAD>
<TITLE>Breadth-First-Search-Traversal</TITLE>
</HEAD>
<BODY>

This algorithm traverses a graph in breadth-first
order and visualises the predecessor tree being built.

</BODY></HTML>
"""
#--------------------------------------------------------------------------------

PickVertex   = lambda : self.PickVertex(1,None)
label = VertexLabeling()
pred = VertexLabeling()
Neighborhood = lambda v,g=G: g.Neighborhood(v)
Q = Queue()

class MyGraphInformer(GraphInformer):

    def VertexInfo(self,v):
	if label[v]:
	    return "Vertex %d - label %d - pred %d"%(v,label[v],pred[v])
	elif v in Q.contents:
            return "Vertex %d - Queue position %d"%(v,Q.contents.index(v)+1)
	else:
            return "Vertex %d - not visited yet"%v
        return

A.SetAllVerticesColor("green")

for v in G.vertices:
    label[v] = None
    pred[v]  = None

A.RegisterGraphInformer(MyGraphInformer(G))
